import 'dart:async';
import 'dart:convert';
import 'package:lori_sdk/data/models/cart/cart.dart';
import 'package:lori_sdk/data/models/singleton/cartSingleton.dart';
import 'package:shared_preferences/shared_preferences.dart';

// TODO fazer refactor depois
class CartPersistence {
  static const _CART_KEY = 'x_cart';

  SharedPreferences db;

  Future open() async {
    if (db == null) {
      db = await SharedPreferences.getInstance();
    }
  }

  Future<Cart> get() async {
    await open();
    final cartInJson = db.getString(_CART_KEY);
    return cartInJson != null ? Cart.fromJson(jsonDecode(cartInJson)) : null;
  }

  Future<void> insertOrUpdate(Cart cart) async {
    var storedResponse = await get();
    await open();
    if (storedResponse == null) {
      await db.setString(_CART_KEY, jsonEncode(cart.toJson()));
      CartSingleton().cartChanged(cart);
    } else {
      db.setString(_CART_KEY, jsonEncode(cart.toJson()));
      CartSingleton().cartChanged(cart);
    }
  }

  Future<void> deleteAll() async {
    await open();
    await db.setString(_CART_KEY, null);
    return CartSingleton().cartChanged(null);
  }
}
